/*
**  ActionController.m
**
**  Copyright (c) 2002, 2003
**
**  Author: Yen-Ju Chen <yjchenx@hotmail.com>
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ActionController.h"
#include <ShengGuang/SongInfo.h>
#include <ShengGuang/SGSound.h>
#include <ShengGuang/CDSound.h>
#include <MusicBox/AudioList.h>
#include <MusicBox/ModuleLoader.h>
#include "PlaylistManager.h"
#include "MusicBoxWindowController.h"
#include "LED.h"
#include <AppKit/AppKit.h>

static int maxTime;
static ActionController *sharedInstance = nil;

@implementation ActionController

/* Use the faciliy of playing for encoding.
 * Block the control which will interfere, too
 */
/*
- (void) encodeSong: (int) track
{
  Class encoderClass;
  NSString *path;
  SongInfo *info;

  nowEncodeTrack = track;

  if (isPlaying)
    {
      isWaitingPlayingStopped = YES;
      [self stop: self];
      return; 
    }

  encoderClass = [[ModuleLoader defaultLoader] classNameOf: [[NSUserDefaults standardUserDefaults] objectForKey: @"EncoderToUse"]];
  encoder = [[encoderClass alloc] initWithOwner: self];

  if (encoder)
    {
      NSFileManager *manager = [NSFileManager defaultManager];
      BOOL isDir;
      isEncoding = YES;

      // block the playing control 
      [[NSNotificationCenter defaultCenter]
               postNotificationName: @"MBControlStatusChanged"
               object: @"Encoding"];

      path = [[[[playlistManager mainLibrary] property] objectForKey: @"path"] stringByStandardizingPath];
      NSLog(@"path %@", path);
      if ([manager fileExistsAtPath: path isDirectory: &isDir] == NO)
        {
          [manager createDirectoryAtPath: path
                               attributes: nil];
        }
      else if (isDir == NO)
        {
           NSRunAlertPanel(_(@"Encoder error"),
                 _(@"Warning: the destinated directory is occupied"),
                 _(@"OK"),
                 nil,
                 nil);
           return; 
        }

      info = [playlistManager songInfoForPlayAtIndex: nowEncodeTrack];
      path = [path stringByAppendingPathComponent: [info artist]];

      if ([manager fileExistsAtPath: path isDirectory: &isDir] == NO)
        {
          [manager createDirectoryAtPath: path
                               attributes: nil];
        }
      else if (isDir == NO)
        {
           NSRunAlertPanel(_(@"Encoder error"),
                 _(@"Warning: the destinated directory is occupied"),
                 _(@"OK"),
                 nil,
                 nil);
           return;
        }

      path = [path stringByAppendingPathComponent: [info album]];

      if ([manager fileExistsAtPath: path isDirectory: &isDir] == NO)
        {
          [manager createDirectoryAtPath: path
                               attributes: nil];
        }
      else if (isDir == NO)
        {
           NSRunAlertPanel(_(@"Encoder error"),
                 _(@"Warning: the destinated directory is occupied"),
                 _(@"OK"),
                 nil,
                 nil);
           return;
        }

      [info setFilename: [NSString stringWithFormat: @"%@/%@_%@.ogg", 
                                                     path, 
                                                     [info track],
                                                     [info song]]];
      // Set up timer
      if (timer == nil) {
        timer = [NSTimer scheduledTimerWithTimeInterval: 1
                                                 target: self
                                               selector: @selector(updateLED)
                                               userInfo: nil
                                                repeats: YES];
      }

      [encoder setSongInfo: info];
      [encoder launch];
    }
  else
    {
      NSRunAlertPanel(_(@"Encoder error"), 
                      _(@"Warning: The encoder is not set up properly."),
                                   _(@"OK"),
                                   nil,
                                   nil);
    }
}

- (void) encoder: (id <EncoderModule>) object didFinishEncoding: (BOOL) bool
{
  int i, nextSong = -1;
  SongInfo *info;

  [LEDStatus setObject: [NSNumber numberWithInt: 100]
                forKey: @"percent"];   
  [led setLEDStatus: LEDStatus];

  if (bool == YES)
    {
      info = [SongInfo new];
      [info setSong: [[encoder songInfo] song]];
      [info setArtist: [[encoder songInfo] artist]];
      [info setAlbum: [[encoder songInfo] album]];
      [info setDuration: [[encoder songInfo] duration]];
      [info setFilename: [[encoder songInfo] filename]];
      [info setSound: [[SGSound alloc] initWithContentsOfFile: [info filename]
                                                  byReference: YES]];
      [[playlistManager mainLibrary] addObject: info];
      RELEASE(info);

      [[NSNotificationCenter defaultCenter]
               postNotificationName: @"MBShouldReloadTableViewData"
               object: nil];
    }
      
  NSLog(@"%@ finish encoding", object);
  RELEASE(object);
  encoder = nil;
 
  if (bool == YES)
    {
      // Search for next checked song 
      for(i = 0; i < [[playlistManager listForPlay] count]; i++)
        if ([[playlistManager songInfoForPlayAtIndex: i] checked])
          {
            if (i > nowEncodeTrack)
              {
                nextSong = i;
                break;
              }
          }

      NSLog(@"Encode next song %d", nextSong);
    }

  if (nextSong == -1) // No more encoding
    {
      isEncoding = NO;

      // resume the playing control 
      [[NSNotificationCenter defaultCenter]
               postNotificationName: @"MBControlStatusChanged"
               object: @"EncodingStopped"];

      [LEDStatus removeObjectForKey: @"encoding"];
      [led setLEDStatus: LEDStatus];

      if (timer) {
        [timer invalidate];
        timer = nil;
      }
    }
  else
    {
      nowEncodeTrack = nextSong;
      [self encodeSong: nowEncodeTrack];
    }
}
*/

- (void) seek: (NSNumber *) seconds by: (id) sender
{
  /* has to calcuate the right seconds */
  [(SGSound *)[playingSongInfo sound] seek: [seconds intValue]];
}

- (void) setShuffle: (id) sender
{
  /* Generate random seed. dayOfCommonEra is never repeat */
  srandom([[NSCalendarDate calendarDate] secondOfMinute] *
          [[NSCalendarDate calendarDate] minuteOfHour] *
          [[NSCalendarDate calendarDate] dayOfCommonEra]);
  NSLog(@"Random number %d", random());
}

- (void) setRepeat: (id) sender
{
  if ([sender state] == 0)
    isRepeat = NO;
  else
    isRepeat = YES;
}

- (void) sound: (NSSound *) aSound didFinishPlaying: (BOOL) aBool
{

  /* Resume the status in MusicBoxWindow*/
  if ([aSound isKindOfClass: [CDSound class]])
    [playingSongInfo setStatus: [NSString stringWithFormat: @"%d", [(CDSound *)aSound track]+1]];
  else
    [playingSongInfo setStatus: @""];

  /* Update playing time if necessary */
  if ([[playingSongInfo duration] intValue] < maxTime) 
    [playingSongInfo setDuration: [NSString stringWithFormat: @"%d",maxTime]];

  [[NSNotificationCenter defaultCenter]
           postNotificationName: @"MBShouldReloadTableViewData"
           object: nil];

  maxTime = 0;

  NSLog(@"DidFinish: nowPlayTrack %d", nowPlayTrack);

  if (willContinue) 
    {
      // Decide next song
      if (nextPlayTrack < 0) // Undecided
        nextPlayTrack = [self _nextSong];

      NSLog(@"DidFinish: nextPlayTrack %d", nextPlayTrack);
      NSLog(@"Current playlist %d", [playlistManager indexOfSelectedPlaylist]);

      /* if nextPlayTrack == nowPlayTrack,
       * it means it reach the end of play list.
       * Stop if it is the case.
       */
      if ((nextPlayTrack != nowPlayTrack) && (nextPlayTrack > -1))
        {
          nowPlayTrack = nextPlayTrack;
          [self _playSong];
          return;
        }

      if (isRepeat) 
        {
          // Restart from beginning
          /* reset nowPlayTract in order to get real next song */
          nowPlayTrack = -1;
          nowPlayTrack = [self _nextSong];
          [self _playSong];
          return;
        }
    }

  currentState = ActionControllerStopped;
  NSLog(@"DidFinish: stop completely");

  // When willContinue = NO, OR, reach the end of play list
  if (timer) {
    [timer invalidate];
    DESTROY(timer);
  }

  // Reset 
  nowPlayTrack = nextPlayTrack = -1;

  [led setState: currentState];

  [[NSNotificationCenter defaultCenter]
           postNotificationName: @"MBControlStatusChanged"
           object: @"Stopped"];

/*
  if (isWaitingPlayingStopped == YES)
    {
      [self encodeSong: nowEncodeTrack];
      isWaitingPlayingStopped = NO;
    }
*/
}

- (void) doubleClickAction: (id)sender
{
  willContinue = YES;
  [playlistManager syncPlaylist];

  if ( (currentState == ActionControllerPlaying) ||
       (currentState == ActionControllerPaused) )
    {
      nextPlayTrack = [playlistManager indexOfSelectedSongForPlay];
      [[playingSongInfo sound] stop];
      currentState = ActionControllerStopping;
    }
  else
    {
      nowPlayTrack = [playlistManager indexOfSelectedSongForPlay];
      [self _playSong];
    }
}

- (ActionControllerState) currentState
{
  return currentState;
}

- (SongInfo *) playingSongInfo
{
  return playingSongInfo;
}

- (void) updateLED: (id) sender
{
/*
  int time;

  if (isPlaying) 
    {
//      [LEDStatus setObject: playingSongInfo forKey: @"song"];
      [LEDStatus setObject: [(SGSound *)[playingSongInfo sound] currentTime]
                    forKey: @"time"];
//      [LEDStatus setObject: @"YES" forKey: @"playing"];

      // Prepare to calculate the correct duration 
      time = [[(SGSound *)[playingSongInfo sound] currentTime] intValue];
      if (maxTime < time)
        maxTime = time;
    }
  else if (isEncoding)
    {
      [LEDStatus setObject: [playlistManager songInfoForPlayAtIndex: nowEncodeTrack]
                    forKey: @"song"];
      [LEDStatus setObject: [NSNumber numberWithInt: [encoder progress]]
                    forKey: @"percent"];
      [LEDStatus removeObjectForKey: @"playing"];
      [LEDStatus setObject: @"YES" forKey: @"encoding"];
    }
  else
    {
      return;
    }
*/
  [led setState: currentState];
}

/* This is called only when play button is press.
 * Always search from the beginning of play list.
 */
- (void) play: (id)sender
{
  [[playlistManager mainWindowController] browserView: self];
  NSLog(@"currentState %d", currentState);

  if (currentState == ActionControllerStopped)
    {
      int i;
      unsigned count;

      nowPlayTrack = -1;
      willContinue = YES;
      /* Sync playlist */
      [playlistManager syncPlaylist];
      nowPlayTrack = [self _nextSong];
/*
      count = [[playlistManager soundListForPlay] count];

      if (count < 1)
        return;

      // Find the first checked 
      for(i = 0 ; i < count; i++)
        if([[playlistManager songInfoForPlay:i] checked]) {
          nowPlayTrack = i; 
          break;
        }

      // If no song is checked, start playing from the selected row. 
      if (nowPlayTrack < 0) {
        nowPlayTrack = [playlistManager indexOfSelectedSongForPlay];
      }
*/
      /* If no row is selected, start playing at the first sound. */
      if (nowPlayTrack < 0)
        nowPlayTrack = 0;

      [self _playSong];
    }
  else if (currentState == ActionControllerPaused) 
    {
      [[NSNotificationCenter defaultCenter]
           postNotificationName: @"MBControlStatusChanged"
           object: @"Playing"];

      [[playingSongInfo sound] resume];
      currentState = ActionControllerPlaying;
    }
}

- (void) next: (id)sender
{
  [[playlistManager mainWindowController] browserView: self];

  if( (currentState == ActionControllerPlaying) ||
      (currentState == ActionControllerPaused) ) 
    {
      willContinue = YES;
    }
  else 
    {
      [playlistManager syncPlaylist];
      willContinue = NO;
    }
  
  nextPlayTrack = [self _nextSong];

  // Last song in the check list
  if (nextPlayTrack == nowPlayTrack)
     return; 
  if (nextPlayTrack == -1)
     return;

  if ( (currentState == ActionControllerPlaying) ||
       (currentState == ActionControllerPaused) )
    {
      [[playingSongInfo sound] stop];
      currentState = ActionControllerStopping;
    }
  else
    [[NSNotificationCenter defaultCenter]
           postNotificationName: @"MBSelectedSongInfoShouldChange"
           object: [NSNumber numberWithInt: nextPlayTrack]];
}

- (void) prev: (id)sender
{
  [[playlistManager mainWindowController] browserView: self];

  if( (currentState == ActionControllerPlaying) ||
       (currentState == ActionControllerPaused) )
    {
      willContinue = YES;
    }
  else 
    {
      [playlistManager syncPlaylist];
      willContinue = NO;
    }

  nextPlayTrack = [self _prevSong];

  // Last song in checked list
  if (nextPlayTrack == nowPlayTrack)
    return; 
  if (nextPlayTrack < 0)
    return;

  if ( (currentState == ActionControllerPlaying) ||
       (currentState == ActionControllerPaused) )
    {
      [[playingSongInfo sound] stop];
      currentState = ActionControllerStopping;
    } 
  else
    [[NSNotificationCenter defaultCenter]
           postNotificationName: @"MBSelectedSongInfoShouldChange"
           object: [NSNumber numberWithInt: nextPlayTrack]];
}

- (void) stop: (id)sender
{
  if ( (currentState == ActionControllerPlaying) || 
       (currentState == ActionControllerPaused) ) 
    {
      willContinue = NO;

      if (sender == led)
        {
          // Special case. Stop from LED
          //   means to play the whoe play list 
          willContinue = YES;
          [playlistManager selectPlaylistForPlay: [playlistManager indexOfSelectedPlaylist]];
          [playlistManager selectSongForPlay: 0];
          nowPlayTrack = -1;
          nextPlayTrack = -1;
        }

      [[playingSongInfo sound] stop];
      currentState = ActionControllerStopping;
    }
/*
  else if (isEncoding == YES) // When encoding 
    {
      NSLog(@"Stop encoding");
      [encoder interrupt];
    }
*/
}

- (void) pause: (id)sender
{
  if (currentState == ActionControllerPlaying)
    {
      [[playingSongInfo sound] pause];
      currentState = ActionControllerPaused;

      [[NSNotificationCenter defaultCenter]
           postNotificationName: @"MBControlStatusChanged"
           object: @"Paused"];
    }
}

- (id) init
{
  ModuleLoader *loader;
  Class bundleClass;
  NSBundle *bundle;
  NSString *bundlePath;

  self = [super init];

  /* Set up all play list */
  playlistManager = [PlaylistManager sharedManager];

  nowPlayTrack = -1;
  nextPlayTrack = -1;

  currentState = ActionControllerStopped;

  willContinue = NO;
  isShuffle = NO;
  isRepeat = NO;
  maxTime = 0;

/*
  isEncoding = NO;
  isWaitingPlayingStopped = NO;
  nowEncodeTrack = -1;
*/

  /* Load mixer bundle */
  loader = [ModuleLoader defaultLoader];
  bundleClass = [loader classNameOf: @"Mixer.bundle"];
  if (bundleClass)
    {
      mixer = [bundleClass sharedMixer];
      [mixer setCurrentBalance: 0.0];
      [mixer setCurrentChannel: 0];
    }
  else
    {
      NSLog(@"Failed to get Class from Mixer.bundle");
    }
  return self;
}

- (void) dealloc
{
  RELEASE(led);
  RELEASE(mixer);
  RELEASE(playingSongInfo);
  [super dealloc];
}

+ (id) sharedController
{
  if (!sharedInstance)
    {
      sharedInstance = [[ActionController alloc] init];
    }
  return sharedInstance;
}

- (void) setLED: (id) object
{
  ASSIGN(led, object);
}

- (void) sliderAction: (id) sender
{
  if ([sender floatValue] >= 0)
    {
      [mixer setCurrentChannel: 0];
      [mixer setCurrentBalance: 0];
      [mixer setCurrentVolume: [sender floatValue]];
    }
}

- (float) volume
{
  [mixer setCurrentChannel: 0];
  [mixer setCurrentBalance: 0];
  return [mixer currentVolume];
}

@end

@implementation ActionController (Private)

/* Make sure that there is no song playing before call this method */
- (void) _playSong
{
  NSLog(@"_playSong: now play %d", nowPlayTrack);

  // Set up timer
  if (timer == nil) {
    timer = [NSTimer scheduledTimerWithTimeInterval: 1
                                             target: self
                                           selector: @selector(updateLED:)
                                           userInfo: nil
                                            repeats: YES];
    RETAIN(timer);
  } 

  ASSIGN(playingSongInfo, [playlistManager songInfoForPlay: nowPlayTrack]);

  if ([playingSongInfo sound] == nil) {
    [playingSongInfo loadSound];
  }

  [[playingSongInfo sound] setDelegate: self];

  [[playingSongInfo sound] play];
  currentState = ActionControllerPlaying;

  [playingSongInfo setStatus: @"Play"];

  [[NSNotificationCenter defaultCenter]
           postNotificationName: @"MBShouldReloadTableViewData"
           object: nil];

  [[NSNotificationCenter defaultCenter]
           postNotificationName: @"MBControlStatusChanged"
           object: @"Playing"];
}

/* With a given nowPlayTrack, find the next/prev song.
 * If it is out of the range of listForPlay, return -1.
 * These methods don't consider isRepeat or isShuffle.
 */
- (int) _nextSong
{
  int i, now, next = -1;
  unsigned count;

  /* Set the beginning of search */

  count = [[playlistManager soundListForPlay] count];
  if (count == 0)
    return -1;

  /* Because the selected song in tableview 
   * might not be the same as the playing song.
   * Choose the right one depending on whether willContinue;
   */
  if( willContinue )
    {
      now = nowPlayTrack;
    }
  else 
    {
      /* selectedSongForPlay is changed only after sync */
      now = [playlistManager indexOfSelectedSongForPlay];
      if (now < 0)
        now = 0;
    }

  /* Search the checked song first */
  for(i = 0; i < count; i++)
    if([[playlistManager songInfoForPlay: i] checked]) {
      next = i;
      if (next > now) 
        break;
    }

  // No checked song
  if (next == -1) 
    next = now + 1;

  if (next > count-1)
    return -1;
  else
    return next;
}

- (int) _prevSong
{
  int i, count, now, prev = -1;

  count = [[playlistManager soundListForPlay] count];
  if (count == 0)
    return -1;

  if ( willContinue )
    {
      now = nowPlayTrack;
    } 
  else 
    {
      now = [playlistManager indexOfSelectedSongForPlay];
      if (now < 0)
        now = 0;
    }

  i = count - 1;

  for( ; i > -1; i--)
    if([[playlistManager songInfoForPlay: i] checked]) {
      prev = i;
      if (prev < now) 
            break;
    }

  // No checked song
  if (prev == -1)
    prev = now - 1;

  return prev;
}

@end
