/*
**  CddbWindowController.h
**
**  Copyright (c) 2002, 2003
**
**  Author: Yen-Ju Chen <yjchenx@hotmail.com>
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _Musicbox_MusicBox_AudioModule_H_CddbWindowController
#define _Musicbox_MusicBox_AudioModule_H_CddbWindowController

#include <AppKit/NSWindowController.h>

@class NSTableView;
@class NSTableColumn;
@class NSArray;

@interface CddbWindowController: NSWindowController
{
  NSTableView *tableView;
  NSArray *dataSource;
  int userSelection;
}

// action methods

- (void) okClicked: (id) sender;
- (void) cancelClicked: (id) sender;
- (void) doubleClickOnTable: (id) sender;

- (void) setDataSource: (NSArray *) array;
- (int) userSelection;

- (int) numberOfRowsInTableView: (NSTableView *) view;
- (id) tableView: (NSTableView *) view
                  objectValueForTableColumn: (NSTableColumn *) column
                  row: (int) row;

@end

#endif /* _Musicbox_MusicBox_AudioModule_H_CddbWindowController */
