/*
**  LED.h
**
**  Copyright (c) 2002, 2003
**
**  Author: Yen-Ju Chen <yjchenx@hotmail.com>
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _Musicbox_MusicBox_H_LED
#define _Musicbox_MusicBox_H_LED

#include <AppKit/NSView.h>
#include <AppKit/NSDragging.h>
#include "ActionController.h"

@class NSMutableString;
@class NSImage; 

@interface LED : NSView
{
  NSMutableString *firstLine, *secondLine, *timeLine;
  int firstSize, secondSize;
  NSMutableDictionary *firstAttr, *secondAttr, *timeAttr;
  int percent, bar; 
  BOOL hasAction, isDragging;
  BOOL hasStop;
  BOOL canDrag;
  NSSize iconSize;
  NSRect barFrame;
  int totalTime;
  NSImage *gnuspace;
  ActionController *actionController;
  ActionControllerState currentState;
}

- (void) setState: (ActionControllerState) state;

/* Drop from playlist window */
- (NSDragOperation) draggingEntered: (id <NSDraggingInfo>) sender;
- (BOOL) prepareForDragOperation: (id <NSDraggingInfo>) sender;
- (BOOL) performDragOperation: (id <NSDraggingInfo>) sender;

@end

#endif /* _Musicbox_MusicBox_H_LED */
