/*
**  PlayerView.h
**
**  Copyright (c) 2003
**
**  Author: Yen-Ju Chen <yjchenx@hotmail.com>
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _Musicbox_MusicBox_H_PlayerView
#define _Musicbox_MusicBox_H_PlayerView

#include <AppKit/NSView.h>

@class PlaylistManager;
@class ActionController;
@class AudioList;
@class NSButton;
@class NSSlider;
@class NSNotification;

@interface PlayerView: NSView
{
  NSButton *prev, *play, *next;
  NSSlider *slider;

  PlaylistManager *playlistManager;
  ActionController *actionController;
  id led;
}

- (NSButton *) prevButton;
- (NSButton *) playButton;
- (NSButton *) nextButton;
- (NSSlider *) slider;

- (void) play: (id) sender;
- (void) next: (id) sender;
- (void) prev: (id) sender;
- (void) pause: (id) sender;

- (void) setLED: (id) led;
- (void) controlStatusChanged: (NSNotification *) not;

@end

#endif /* _Musicbox_MusicBox_H_PlayerView */

