/*
**  PlaylistWindowController.h
**
**  Copyright (c) 2002, 2003
**
**  Author: Yen-Ju Chen <yjchenx@hotmail.com>
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _Musicbox_MusicBox_H_PlaylistWindowController
#define _Musicbox_MusicBox_H_PlaylistWindowController

#include <AppKit/AppKit.h>

@class PlaylistManager;
@class IconTableView;
/*
@class MusicBoxWindow;
@class MusicBoxWindowController;
*/

@interface PlaylistWindowController : NSWindowController
{
  IconTableView *tableView;
  NSButton *addButton, *editButton, *deleteButton;
  PlaylistManager *playlistManager;
  NSButton *additionalButton;
  BOOL useMultipleWindows;
}

/* playlist management and menu action */
- (void) deletePlaylist: (id) sender;
- (void) addPlaylist: (id) sender;
- (void) editPlaylist: (id) sender;
//- (MusicBoxWindow *) windowOfName: (NSString *) name;

/* delegate of NSTableView */
- (void) tableViewSelectionDidChange: (NSNotification *) not;
/* Drop */
- (BOOL) tableView: (NSTableView*)tableView
        acceptDrop: (id <NSDraggingInfo>)info
               row: (int)row
     dropOperation: (NSTableViewDropOperation)operation;
- (NSDragOperation) tableView: (NSTableView*)tableView
                 validateDrop: (id <NSDraggingInfo>)info
                  proposedRow: (int)row
        proposedDropOperation: (NSTableViewDropOperation)operation;
/* Drag */
- (BOOL) tableView: (NSTableView *) aView
         writeRows: (NSArray *) rows
      toPasteboard: (NSPasteboard *) pboard;
/* Data Source */
- (int) numberOfRowsInTableView: (NSTableView *)aView;
- (id) tableView: (NSTableView *) aView
                  objectValueForTableColumn: (NSTableColumn *) aColumn
                  row: (int) row;
- (void) tableViewSelectionDidChange: (NSNotification *) not;
/*  Action */
- (void) doubleClickOnTable: (id) sender;
@end

#endif /* _Musicbox_MusicBox_H_PlaylistWindowController */
