/*
**  FreeDBView.m
**
**  Copyright (c) 2002
**
**  Author: Yen-Ju Chen <yjchenx@hotmail.com>
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "FreeDBView.h"
#include <AppKit/AppKit.h>

@implementation FreeDBView

- (id) initWithFrame: (NSRect) frame
{
  NSTextField *freedbLabel, *freedbDesc;
  NSTableColumn *siteColumn, *locationColumn;
  NSScrollView *scrollView;
  NSRect rect;

  self = [super initWithFrame: frame];

  rect = NSMakeRect(5, frame.size.height-70, frame.size.width-10, 66);
  freedbDesc = [[NSTextField alloc] initWithFrame: rect];
  [freedbDesc setEditable: NO];
  [freedbDesc setSelectable: NO];
  [freedbDesc setBezeled: NO];
  [freedbDesc setDrawsBackground: NO];
  [freedbDesc setStringValue: _(@"Set your freedb site.")];
  [freedbDesc setAutoresizingMask: NSViewMinYMargin | NSViewWidthSizable];
  [self addSubview: freedbDesc];
  RELEASE(freedbDesc);
  
  rect = NSMakeRect(5, frame.size.height-100, 80, 22);
  freedbLabel = [[NSTextField alloc] initWithFrame: rect];
  [freedbLabel setEditable: NO];
  [freedbLabel setSelectable: NO];
  [freedbLabel setBezeled: NO];
  [freedbLabel setDrawsBackground: NO];
  [freedbLabel setStringValue: _(@"Freedb site:")];
  [freedbLabel setAutoresizingMask: NSViewMinYMargin | NSViewMaxXMargin];
  [self addSubview: freedbLabel];
  RELEASE(freedbLabel);
  
  rect = NSMakeRect(90, frame.size.height-100, frame.size.width-95, 22);
  freedbField = [[NSTextField alloc] initWithFrame: rect];
  [freedbField setEditable: YES];
  [freedbField setSelectable: YES];
  [freedbField setBezeled: YES];
  [freedbField setDrawsBackground: NO];
  [freedbField setAutoresizingMask: NSViewMinYMargin | NSViewWidthSizable];
  [self addSubview: freedbField];
  RELEASE(freedbField);

  siteColumn = [[NSTableColumn alloc] initWithIdentifier: @"site"];
  [siteColumn setEditable: NO];
  [siteColumn setMinWidth: 40];
  [[siteColumn headerCell] setStringValue: _(@"Site")];

  locationColumn = [[NSTableColumn alloc] initWithIdentifier: @"location"];
  [locationColumn setEditable: NO];
  [locationColumn setMinWidth: 40];
  [[locationColumn headerCell] setStringValue: _(@"Location")];

  tableView = [[NSTableView alloc] initWithFrame: NSMakeRect(0, 0, 100, 80)];
  [tableView setDrawsGrid: NO];
  [tableView addTableColumn: siteColumn];
  [tableView addTableColumn: locationColumn];
  [tableView setAllowsColumnSelection: NO];
  [tableView setAutoresizesAllColumnsToFit: YES];
  [tableView setAutoresizingMask: NSViewWidthSizable | NSViewHeightSizable];
  RELEASE(siteColumn);
  RELEASE(locationColumn);

  rect = NSMakeRect(5, 45, frame.size.width-10, frame.size.height-45-105);
  scrollView = [[NSScrollView alloc] initWithFrame: rect];
  [scrollView setDocumentView: tableView];
  [scrollView setHasHorizontalScroller:NO];
  [scrollView setHasVerticalScroller:YES];
  [scrollView setBorderType: NSBezelBorder];
  [scrollView setAutoresizingMask: NSViewWidthSizable | NSViewHeightSizable];

//  [tableView setFrame: [scrollView documentVisibleRect]];
  
  [self addSubview: scrollView];                                     
  RELEASE(tableView);
  RELEASE(scrollView);

  button = [[NSButton alloc] initWithFrame: NSMakeRect(5, 5, 200, 30)];
  [button setButtonType: NSMomentaryPushButton];
  [button setStringValue: _(@"Get freedb list from internet")];
  [self addSubview: button];
  RELEASE(button);

  return self;
}

- (NSTextField *) freedbField
{
  return freedbField;
}

- (NSTableView *) tableView
{
  return tableView;
}

- (NSButton *) button
{
  return button;
}

@end
