/*
**  GeneralView.m
**
**  Copyright (c) 2003
**
**  Author: Yen-Ju Chen <yjchenx@hotmail.com>
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "GeneralView.h"
#include <AppKit/AppKit.h>

@implementation GeneralView

- (id) initWithFrame: (NSRect) frame
{
  NSTextField *playlistLabel, *playlistDesc;
  NSRect rect;

  self = [super initWithFrame: frame];

  rect = NSMakeRect(5, frame.size.height-30, 400, 22);
  playlistDesc = [[NSTextField alloc] initWithFrame: rect];
  [playlistDesc setEditable: NO];
  [playlistDesc setSelectable: NO];
  [playlistDesc setBezeled: NO];
  [playlistDesc setDrawsBackground: NO];
  [playlistDesc setStringValue: _(@"Set the file to store your play list.")];
  [playlistDesc setAutoresizingMask: NSViewMinYMargin | NSViewMaxXMargin];
  [self addSubview: playlistDesc];
  RELEASE(playlistDesc);

  rect = NSMakeRect(5, frame.size.height-60, 120, 22);
  playlistLabel = [[NSTextField alloc] initWithFrame: rect];
  [playlistLabel setEditable: NO];
  [playlistLabel setSelectable: NO];
  [playlistLabel setBezeled: NO];
  [playlistLabel setDrawsBackground: NO];
  [playlistLabel setStringValue: _(@"Play list File:")];
  [playlistLabel setAutoresizingMask: NSViewMinYMargin | NSViewMaxXMargin];
  [self addSubview: playlistLabel];
  RELEASE(playlistLabel);

  rect = NSMakeRect(130, frame.size.height-60, frame.size.width-130-5, 22);
  playlistField = [[NSTextField alloc] initWithFrame: rect];
  [playlistField setEditable: YES];
  [playlistField setSelectable: YES];
  [playlistField setBezeled: YES];
  [playlistField setDrawsBackground: NO];
  [playlistField setAutoresizingMask: NSViewMinYMargin | NSViewWidthSizable];
  [self addSubview: playlistField];
  RELEASE(playlistField);

  rect = NSMakeRect(5, frame.size.height-90, frame.size.width-10, 22);
  multiWindowsButton = [[NSButton alloc] initWithFrame: rect];
  [multiWindowsButton setButtonType: NSSwitchButton];
  [multiWindowsButton setStringValue: _(@"Use multiple windows when double-clicked (need restart)")];
  [multiWindowsButton setBordered: NO];
  [multiWindowsButton setState: NO];
  [multiWindowsButton setAutoresizingMask: NSViewMinYMargin | NSViewWidthSizable];
  [self addSubview: multiWindowsButton];
  RELEASE(multiWindowsButton);

  return self;
}

- (NSTextField *) playlistField
{
  return playlistField;
}

- (NSButton *) multiWindowsButton
{
  return multiWindowsButton;
}

@end
