/*
**  GeneralViewController.m
**
**  Copyright (c) 2003
**
**  Author: Yen-Ju Chen <yjchenx@hotmail.com>
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "GeneralViewController.h"
#include "GeneralView.h"
#include <AppKit/AppKit.h>

@implementation GeneralViewController

- (id) init
{
  self = [super init];

  view = [[GeneralView alloc] initWithFrame: NSMakeRect(0, 0, 400, 200)];

  playlistField = [view playlistField];
  multiWindowsButton = [view multiWindowsButton];

  [self initializeFromDefaults];

  return self;
}

- (void) dealloc
{
  RELEASE(view);
  [super dealloc];
}

- (NSImage *) image
{
/*
  NSBundle *aBundle;
  
  aBundle = [NSBundle bundleForClass: [self class]];
  
  return AUTORELEASE([[NSImage alloc] initWithContentsOfFile:
		[aBundle pathForResource: @"fonts" ofType: @"tiff"]]);
*/
  return nil;
}

- (NSString *) name
{
  return _(@"General");
}

- (NSView *) view
{
  return view;
}

- (BOOL) hasChangesPending
{
  return YES;
}

- (void) initializeFromDefaults
{
  if ( [[NSUserDefaults standardUserDefaults] objectForKey: @"PlaylistFile"] )
    {
      [playlistField setStringValue: [[NSUserDefaults standardUserDefaults]
                                       stringForKey: @"PlaylistFile"]];
      [multiWindowsButton setState: [[NSUserDefaults standardUserDefaults]
                                       boolForKey: @"UseMultipleWindows"]];
    }
}

- (void) saveChanges
{
  [[NSUserDefaults standardUserDefaults] setObject: [playlistField stringValue]
                                            forKey: @"PlaylistFile"];
  [[NSUserDefaults standardUserDefaults] setBool: [multiWindowsButton state]
                                          forKey: @"UseMultipleWindows"];
}

@end
