/*
**  SourceEditorWindowController.h
**
**  Copyright (c) 2002, 2003
**
**  Author: Yen-Ju Chen <yjchenx@hotmail.com>
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _Musicbox_MusicBox_H_SourceEditorWindowController
#define _Musicbox_MusicBox_H_SourceEditorWindowController

#include <AppKit/NSWindowController.h>

@class AudioList;
@class AudioListView;
@class NSBox;
@class NSPopUpButton;
@class NSButton;
@class NSMutableArray;
@class NSArray;


@interface SourceEditorWindowController: NSWindowController
{
  NSBox *box;
  NSPopUpButton *typeButton;
  NSButton *okButton, *cancelButton;

  AudioList *playlist;
  AudioListView *playlistView;
  NSMutableArray *allClasses;
  NSArray *existingNames;
}

// action methods

- (void) okAction: (id) sender;
- (void) cancelAction: (id) sender;
- (void) typeButtonAction: (id) sender;

- (void) setPlaylist: (AudioList *) playlist; 
- (void) setExistingNames: (NSArray *) array;

// get new source
- (AudioList *) newPlaylist;

@end

#endif /* _Musicbox_MusicBox_H_SourceEditorWindowController */
