/*
**  TagEditorPanelController.h
**
**  Copyright (c) 2002, 2003
**
**  Author: Yen-Ju Chen <yjchenx@hotmail.com>
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _Musicbox_MusicBox_H_TagEditorPanelController
#define _Musicbox_MusicBox_H_TagEditorPanelController

#include <AppKit/NSWindowController.h>

@class SongInfo;
@class NSTextField;
@class NSButton;
@class NSNotification;

@interface TagEditorPanelController: NSWindowController
{
  // Outlets
  NSTextField *songField, *artistField, *albumField;
  NSButton *writeButton, *okButton, *cancelButton, *applyButton;
  NSTextField *channelsField, *rateField, *bitrateField, *lengthField;
  SongInfo *info; 
}

// action methods

- (void) okAction: (id) sender;
- (void) cancelAction: (id) sender;
- (void) applyAction: (id) sender;

- (void) setSongInfo: (NSNotification *) not;

@end

#endif /* _Musicbox_MusicBox_H_TagEditorPanelController */

